#include "./ngc_hs1.h"

#include <cstdint>
#include <new>
#include <unordered_map>

struct _GroupID {
}

struct NGC_HS1 {
	void* temp;

	NGC_HS1_options options;

	// key			- key			- key		- value store
	// group pubkey - peer pubkey	- msg_id	- message(type + text)
};

NGC_HS1* NGC_HS1_new(const struct NGC_HS1_options* options) {
	NGC_HS1* context = new NGC_HS1;

	context->options = *options;

	return context;
}

void NGC_HS1_kill(NGC_HS1* ngc_hs1_ctx) {
	delete ngc_hs1_ctx;
}

void NGC_HS1_iterate(Tox *tox, NGC_HS1* ngc_hs1_ctx/*, void *user_data*/) {
}

bool NGC_HS1_shim_group_send_message(
	const Tox *tox,
	NGC_HS1* ngc_hs1_ctx,

	uint32_t group_number,

	Tox_Message_Type type, const uint8_t *message, size_t length,

	uint32_t *message_id,
	Tox_Err_Group_Send_Message *error
) {
	uint32_t* msg_id_ptr = message_id;
	uint32_t msg_id_placeholder = 0;
	if (msg_id_ptr == NULL) {
		msg_id_ptr = &msg_id_placeholder;
	}

	bool ret = tox_group_send_message(tox, group_number, type, message, length, msg_id_ptr, error);

	NGC_HS1_record_own_message(tox, group_number, type, message, length, *msg_id_ptr);

	return ret;
}


// record own msg
void NGC_HS1_record_own_message(
	const Tox *tox,
	NGC_HS1* ngc_hs1_ctx,

	uint32_t group_number,

	Tox_Message_Type type, const uint8_t *message, size_t length, uint32_t message_id
) {
	printf("record_own_message %u\n", message_id);
}

